Thu Apr 12 17:06:32 2000  Paolo Bonzini (bonzini@gnu.org)

	*** Version 1.7.4 released

Tue Mar 28 19:28:32 2000  Paolo Bonzini (bonzini@gnu.org)

	* blox/ClassBrow.st: removed debugging statement

Fri Mar 24 18:22:48 2000  Paolo Bonzini (bonzini@gnu.org)

	*** Version 1.7.3 released (fixes packaging problem in 1.7.2)

Mon Mar 13 18:29:03 2000  Paolo Bonzini (bonzini@gnu.org)

	*** Version 1.7.2 released

Tue Feb 22 18:29:03 2000  Paolo Bonzini (bonzini@gnu.org)

	*** Version 1.7.1 released

Tue Feb 15 09:48:25 2000  Paolo Bonzini (bonzini@gnu.org)

	*** Version 1.7 released

Mon Jan 31 14:48:04 2000  Paolo Bonzini (bonzini@gnu.org)

	*** Sixth beta of 1.7 (labeled 1.6.85) released

Mon Jan 31 10:26:37 2000  Paolo Bonzini (bonzini@gnu.org)

	* blox/Notifier.st: updated for recent changes to the inner
	workings of the interpreter (notably, the `terminate interpreter'
	bytecode and the fact that execution environments no longer have
	their selector set to nil)

Wed Dec 29 14:37:49 1999  Paolo Bonzini  (bonzini@gnu.org)

	* blox/BrowShell.st: TranscriptInterface class changed to
	TextCollector -- changed here too.  Also added the ability to
	add custom menus to the browsers' window.

Tue Dec 28 12:17:21 1999  Paolo Bonzini  (bonzini@gnu.org)

	*** Fifth beta of 1.7 (labeled 1.6.84) released

Sat Dec 25 10:56:53 1999  Paolo Bonzini  (bonzini@gnu.org)

	* blox/Inspector.st: added Object>>#basicInspect before guests
	arrive for Xmas...

Tue Dec 21 18:54:03 1999  Paolo Bonzini  (bonzini@gnu.org)

	* blox/PCode.st: moved the SyntaxHighlighter class (now called
	STPluggableParser) to compiler/STParser.st.

Fri Nov 26 20:59:32 1999  Paolo Bonzini  (bonzini@gnu.org)

	*** Fourth beta of 1.7 (labeled 1.6.83) released

Sat Nov 6 17:08:32 1999  Paolo Bonzini  (bonzini@gnu.org)

	* blox/BloxWidgets.st: BContainer uses two sends to self to position
	new children, instead of directly calling #posVert: and #posHoriz:.
	I added this hook because I'm thinking of adding paned windows as
	a subclass of BContainer...

Mon Nov 1 20:07:29 1999  Paolo Bonzini  (bonzini@gnu.org)

	* blox/ClassBrow.st: now works with namespaces.  This mainly meant
	adapting the algorithm for preparing the class list (using the one
	in examples/Publish.st).
	* blox/Inspector.st: now works with namespaces.  This mainly meant
	using #nameIn:
	* blox/MethSetBrow.st: now works with namespaces.  This mainly meant
	using #nameIn:

Sun Oct 31 13:44:52 1999  Paolo Bonzini  (bonzini@gnu.org)

	* blox/BloxBasic.st: fixed bug in #fontHeight: -- was reporting space
	for a line less than asked (that is, was always returning zero when
	asked for the space occupied by a single line!)
	* blox/BloxExtend.st: drop-down widgets in and working.
	* blox/BloxWidgets.st: resizing a popup widget works (fixed usage of
	the Tk packer in BPopupWindow).  Also, BLabels now use word wrapping.
	* blox/test.st: added #dropdownTest.

Sun Oct 31 11:12:34 1999  Paolo Bonzini  (bonzini@gnu.org)

	*** Third beta of 1.7 (labeled 1.6.82) released

	* blox/CtxtInspect.st: for some reason, the context inspector was
	broken; I had to add `self changeState: #text'.  The presence of
	this statement is fine -- for example it is there in the class
	browser too, but I don't understand why it was not needed before...
	* blox/View.st: fixed bug in close (was not answering a Boolean)
	* blox/Manager.st: simplified implementation of #close and #destroyed

Sat Oct 30 12:31:58 1999  Paolo Bonzini  (bonzini@gnu.org)

	* blox/BloxBasic.st: fixed possible divide-by-zero problem in
	geometry management; cached the window size; #posHoriz: and
	#posVert: set and take into account the xOffset, yOffset,
	widthOffset and heightOffset too; added accessors for the offset.
	* blox/ClassBrow.st: fixed erroneous geometry management resulting
	for the change to #posHoriz: and #posVert: (in blox/BloxBasic.st).
	See the NEWS file for more information.

Thu Oct 28 19:51:32 1999  Paolo Bonzini  (bonzini@gnu.org)

	* blox/BloxExtend.st: started implementing drop-down controls

Tue Oct 26 22:57:19 1999  Paolo Bonzini  (bonzini@gnu.org)

	* blox/BloxBasic.st: new algorithm to get Tk widget names (instead of
	`.wNNN' where NNN was an increasing number, `.wOOO' where OOO is the
	base-36 representation of the OOP).  Allowed to implement lots of
	interesting methods such as Blox>>#active, Blox>>#atMouse, ...

Sun Oct 24 00:02:54 1999  Paolo Bonzini  (bonzini@gnu.org)

	* blox/BloxBasic.st: added methods to automatically or manually toggle
	the scrollbars in a BViewport.
	* blox/BloxText.st: added images.

Fri Oct 22 10:15:26 1999  Paolo Bonzini  (bonzini@gnu.org)

	* blox/BloxExtend.st: changed implementation of the progress widget; the
	new one looks nicer and shows some tricks.

	* blox/BloxBasic.st: removed #bindWith:... when possible, replaced with
	(new) #tclEval:with:... methods.
	* blox/BloxWidgets.st: same as above.
	* blox/BloxCanvas.st: same as above.
	* blox/BloxText.st: same as above.

	* blox/ClassBrow.st: added `print bytecodes' mode.
	* blox/Inspector.st: split class into GenericInspector (superclass)
	and Inspector (subclass)
	* blox/DictInspect.st: derived from GenericInspector.
	* blox/StrcInspect.st: derived from GenericInspector.
	* blox/CtxtInspect.st: derived StackInspector from GenericInspector.
	* blox/MethInspect.st: created.

Wed Oct 20 19:05:29 1999  Paolo Bonzini  (bonzini@gnu.org)

	* blox/BloxExtend.st: added GNU image and file/directory icons.
	* blox/BloxWidgets.st: use #displayString in BList.

Mon Oct 17 18:19:12 1999  Paolo Bonzini  (bonzini@gnu.org)

	* blox/Blox.st: removed declaration of forward references
	to nil now that Undeclared is available.
	* blox/Load.st: ditto

	* blox/BloxBasic.st: added pluggable geometry behavior depending
	on the parent widget.  Added #new to BWidget.
	* blox/BloxCanvas.st: new feature above used.
	* blox/BloxText.st: new feature above used.
	* blox/BloxWidgets.st: new feature above used in BPopupWindow.
	* blox/BloxExpand.st: change to BloxWidgets.st exploited in
	BBalloon.

Sun Oct 16 15:00:38 1999  Paolo Bonzini  (bonzini@gnu.org)

	* blox/BloxCanvas.st: Added BEmbeddedImage.
	* blox/BloxWidgets.st: automatically choose a good letter
	(possibly different for each item) to be underlined in a
	menu item.  Also added callbacks to BEdit.
	* blox/View.st: don't use #allSubinstances: (sloooow) to
	iterate through all the views.
	* blox/CtxtInspect.st: make StackInspector get temporaries
	from outer block contexts too.

Wed Oct 13 17:38:49 1999  Paolo Bonzini  (bonzini@gnu.org)

	* blox/ErrInspect.st: became Notifier.st; also class name
	changed to Notifier
	* blox/Load.st: load Notifier.st instead of ErrInspect.st
	* blox/PText.st: don't bring up a notifier when choosing
	`senders' or `implementors' without a selection

	* blox/PCode.st: added syntax highlightling

	* blox/StkInspect.st: incorporated in blox/CtxtInspect.st
	* blox/CtxtInspect.st: incorporated blox/StkInspect.st

Mon Oct 11 17:48:57 1999  Paolo Bonzini  (bonzini@gnu.org)

	* blox/BloxText.st: added a few methods about attributes and lines,
	needed for syntax highlighting.

	* blox/ClassBrow.st: tell PCode the class of the method.
	* blox/MethSetBrow.st: tell PCode the class of the method.
	* blox/CtxtInspect.st: tell PCode the class of the method.
	* blox/PCode.st: added code to let widgets tell PCode the class
	of the method to show.

	* blox/Form.st: incorporated in blox/Manager.st
	* blox/GuiData.st: removed some methods defined in Gui
	(they were unused), added new GuiState class.
	* blox/Load.st: removed files incorporated in other files
	* blox/Manager.st: incorporated blox/Form.st & blox/TopLevel.st
	* blox/ModalDialog.st: incorporated blox/Prompter.st
	* blox/PRadioBtn.st: incorporated in blox/RadioForm.st
	* blox/Primitive.st: incorporated in blox/View.st
	* blox/Prompter.st: incorporated in blox/ModalDialog.st
	* blox/RadioForm.st: incorporated blox/PRadioBtn.st
	* blox/TextMenu.st: removed (it could not be even filed in)
	* blox/TopLevel.st: incorporated in blox/Manager.st
	* blox/View.st: incorporated blox/Primitive.st, used
	new GuiState class.

Sat Oct 9 09:14:23 1999  Paolo Bonzini  (bonzini@gnu.org)

	*** Second beta of 1.7 (labeled 1.6.81) released

Sat Oct 2 14:53:46 1999  Paolo Bonzini  (bonzini@gnu.org)

	* blox/BloxBasic.st: added methods to create CMYK and HSV colors;
	commented.
	* blox/BloxExtend.st: commented.
	* blox/Blox.c: stop compilation if HAVE_TCLTK is not defined

Thu Sep 30 18:00:14 1999  Paolo Bonzini  (bonzini@gnu.org)

	* examples/blox/Man.st: removed code to deal with non-reentrancy
	of event dispatching loops.
	* examples/blox/Tetris.st: removed code to deal with
	non-reentrancy of event dispatching loops.
	* blox/BloxBasic.st: #dispatchEvents and #dispatchEvents: are
	now reentrant.
	* blox/PCode.st: created
	* blox/CtxtInspect.st: use PCode
	* blox/ClassBrow.st: use PCode
	* blox/MethSetBrow.st: use PCode

Sun Sep 26 13:55:21 1999  Paolo Bonzini  (bonzini@gnu.org)

	* blox/BloxBasic.st: added BEventSet; ...Absolute geometry methods
	refer to the container object (used to refer to the connected object);
	added xRoot and yRoot to BWidget.  Use the grid geometry manager
	in BViewport -- it looks nicer.
	* blox/BloxWidgets.st: added BPopupWindow.
	* blox/BloxExtend.st: created
	* blox/BloxIcons.st: removed -- merged in BloxExtend.st
	* blox/test.st: added tests for extended widgets
	* examples/blox/Progress.st: removed -- merged in BloxExtend.st

Sat Sep 25 12:32:23 1999  Paolo Bonzini  (bonzini@gnu.org)

	*** First beta of 1.7 (labeled 1.6.80) released

Tue Sep 20 23:10:48 1999  Paolo Bonzini  (bonzini@gnu.org)

	* blox/Blox.c: incorporated XPM support (partly stolen from libXpm).
	* blox/BloxBasic.st: added #borderWidth accessor.
	* blox/BloxIcons.st: created.
	* blox/rgbtab.h: created.
	* blox/test.st: added #iconTest.

Mon Sep  5 11:07:16 1999  Paolo Bonzini  (bonzini@gnu.org)

	* blox/BloxBasic.st: changed to use the new #idleAdd: method in
	ProcessorScheduler.

Sun Aug 29 11:23:18 1999  Paolo Bonzini  (bonzini@gnu.org)

	*** Version 1.6.2 released.

Wed Jul 14 09:24:51 1999  Paolo Bonzini  (bonzini@gnu.org)

	* blox/StructInspect.st: renamed to StrcInspect.st (was more than
	14 chars long).

Sun Jul  4 16:09:23 1999  Paolo Bonzini  (bonzini@gnu.org)

	* blox/Blox.st: Added BTextBindings and BEdit classes.
	* blox/BloxBasic.st: Added #cursor and #cursor:
	* blox/BloxCanvas.st: Added #at:
	* blox/BloxText.st: Added the ability to specify event handlers
	in a BTextAttributes object.
	* blox/BloxWidgets.st: Added BEdit.
	* blox/test.st: Added #textEventsTest and #editTest.
	
Fri Jun 25 12:53:18 1999  Paolo Bonzini  (bonzini@gnu.org)

	*** Bug-fixing version 1.6.1 released.

Thu Jun 17 11:38:53 1999  Paolo Bonzini  (bonzini@gnu.org)

	*** Version 1.6 released.

Thu May 8 18:25:39 1999  Paolo Bonzini  (bonzini@gnu.org)

	* blox/Transcript.st: Moved to kernel (at last!).
	* blox/Load.st: Removed Transcript.st.
	* blox/BrowserMain.st: Modified code to set up the Transcript.st
	to deal with the new interface for the Transcript object.

Tue Apr 27 20:01:18 1999  Paolo Bonzini  (bonzini@gnu.org)

	*** Version 1.5.beta3 released.
	
Thu Apr 22 00:11:51 1999  Paolo Bonzini  (bonzini@gnu.org)

	* blox/Blox.c: Renamed idle to bloxIdle -- idle was already defined
	in unistd.h.  Signaled by Christopher Painter-Wakefield.

Sun Apr 11 14:03:48 1999  Paolo Bonzini  (bonzini@gnu.org)

	* blox/Blox.st: Removed BEventHandlers, added BEventTarget.
	* blox/BloxBasic.st: Changed event handling design to
	the new one using BEventTarget.  This resembles the old one
	(before Apr 8), but its design is better (no code duplication)
	and it is compatible with beta1.  Switched Blox superclass to
	be BEventTarget.
	* blox/BloxCanvas.st: Changed event handling design to
	the new one using BEventTarget. Switched BCanvasObject superclass
	to be BEventTarget.
	* examples/blox/Progress.st: switched to new event handling system
	(actually, back to the old one...)
	* examples/blox/Tetris.st: switched to new event handling system
	(actually, back to the old one...)

Sat Apr 10 23:19:41 1999  Paolo Bonzini  (bonzini@gnu.org)

	*** Version 1.5.beta2 released.

Thu Apr 8 16:29:19 1999  Paolo Bonzini  (bonzini@gnu.org)

	* blox/Blox.st: Added BEventHandlers.
	* blox/BloxBasic.st: Changed event handling design to
	the new one using #events:/#events.
	* blox/BloxCanvas.st: Changed event handling design to
	the new one using #events:/#events.
	* examples/blox/Progress.st: switched to new event handling system
	* examples/blox/Tetris.st: switched to new event handling system.

Mon Mar 15 20:23:07 1999  Paolo Bonzini  (bonzini@gnu.org)

	*** Version 1.5.beta1 released.

Sat Feb 26 10:10:31 1999  Paolo Bonzini  (bonzini@gnu.org)

	* blox/BloxBasic.st: Added hook into Delay class>>#idle
	* examples/blox/Tetris.st: Removed the `idle' process, whose
	function is now embedded in Delay.st

Fri Feb 26 17:20:42 1999  Paolo Bonzini  (bonzini@gnu.org)

	* blox/Run.st: Now automatically loads `Browser' if needed.
	* blox/ClassBrow.st: #classString used #to:do: with a zero
	argument block (1.1.5 did not find this error)!

Mon Feb 22 12:34:56 1999  Paolo Bonzini  (bonzini@gnu.org)

	* blox/Transcript.st: Made thread-safe.

Tue Feb 16 12:34:56 1999  Paolo Bonzini  (bonzini@gnu.org)

	* blox/BloxWidgets.st: added BWindow>>#resizable

Sun Feb 14 12:34:56 1999  Paolo Bonzini  (bonzini@gnu.org)

	* blox/ClassBrow.st: Happy Valentine! Switched to file prompters.
	* blox/Prompter.st: Added file prompters.
	* examples/blox/Progress.st: created.

Tue Feb  9 12:34:56 1999  Paolo Bonzini  (bonzini@gnu.org)

	* examples/blox/Man.st: created.

Fri Feb  5 12:34:56 1999  Paolo Bonzini  (bonzini@gnu.org)

	* blox/Blox.c: Added idle. Calling TCL's `update' did not seem to
	work.  The Blox.c file was created somewhen in November.
	* examples/blox/Tetris.st: created.

Thu Feb  4 12:34:56 1999  Paolo Bonzini  (bonzini@gnu.org)

	* blox/Transcript.st: Added #instance class method to allow
	using print/printNl even if the GUI is not running.

Wed Feb  3 12:34:56 1999  Paolo Bonzini  (bonzini@gnu.org)

	* blox/BloxCanvas.st: created.

Tue Feb  2 12:34:56 1999  Paolo Bonzini  (bonzini@gnu.org)

	* blox/BloxWidgets.st: added BImage.

Mon Feb  1 12:34:56 1999  Paolo Bonzini  (bonzini@gnu.org)

	* blox/BloxText.st: created from part of BloxWidgets.st.

Tue Jan 26 12:34:56 1999  Paolo Bonzini  (bonzini@gnu.org)

	* blox/ClassBrow.st: Moved instance/class radio buttons under
	the category pane. First it seemed more logical to me, second
	now they steal screen estate from the list box that is less
	likely to scroll.

Sat Nov 28 12:34:56 1998  Paolo Bonzini  (bonzini@gnu.org)

	* blox/BloxBasic.st: Small change to support reloading
	images which used Blox.

Fri Nov 27 12:34:56 1998  Paolo Bonzini  (bonzini@gnu.org)

	* blox/ErrInspect.st: Modified to support unwinding

Tue Nov 24 12:34:56 1998  Paolo Bonzini  (bonzini@gnu.org)

	* blox/Transcript.st: created.

Sun Nov 15 12:34:56 1998  Paolo Bonzini  (bonzini@gnu.org)

	* blox/BloxBasic.st: First version of Tk Blox completed.

Sat Nov 14 12:34:56 1998  Paolo Bonzini  (bonzini@gnu.org)

	* blox/StructInspect.st: Created.

Tue Nov 10 12:34:56 1998  Paolo Bonzini  (bonzini@gnu.org)

	* blox/BrowShell.st: created.
	* blox/BrowserMain.st: Moved some parts to BrowserShell, so that
	every window has a Smalltalk menu; in addition, the main window
	is a worksheet
	* blox/ClassBrow.st: Added support for classes derived from nil.

Tue Nov  3 12:34:56 1998  Paolo Bonzini  (bonzini@gnu.org)

	* blox/Blox.st: created.
	* blox/BloxBasic.st: Added BPrimitive and BExtended. The latter
	is intended to provide a base for implementing megawidgets like
	tree lists, tables, HTML viewers, etc. Also split old Blox.st
	in BloxBasic.st and BloxWidgets.st.
	* blox/BloxWidgets.st: created.

Fri Oct 30 12:34:56 1998  Paolo Bonzini  (bonzini@gnu.org)

	* blox/Menu.st: Modified to add support for menu bars. The previous
	version assumed that you could pass a >>Shell<<	to BMenu when
	creating it. Instead, as BBrowser.st shows, you must pass it a
	menu bar, and the new Tcl-based version enforces this.  The new
	version uses the menuBar method I added to TopLevelShell, which
	automatically creates a menu bar when you add the first menu.
	Note that this change did not affect PopupMenu, because
	BPopupMenu does accept a BWindow as the first parameter passed
	to #new:label:
	* blox/TopLevel.st: Same as above.  The new menuBar
	variable is automatically created when you add a menu.

Tue Oct 20 12:34:56 1998  Paolo Bonzini  (bonzini@gnu.org)

	* blox/blox.c: rewritten.
	* blox/BloxBasic.st: Switched to Tk for portability. Also
	refactored hierarchy: BForm->BContainer->BRadioGroup, added
	BWidget and BViewport, BButton->BRadioButton, Button->BToggle.
	Added a few Tk features: rubber-sheet geometry management,
	3d effects, fonts, for instance.  Also, previously
	badly-documented C-only methods now expose a tidier interface.
	Programs relying on those methods will fail (e.g. the browser
	itself ;-) ).

Mon Sep 14 12:34:56 1998  Paolo Bonzini  (bonzini@gnu.org)

	* blox/Primitive.st: Capitalized class variable name.

Sat Sep 12 12:34:56 1998  Paolo Bonzini  (bonzini@gnu.org)

	* blox/BBrowser.st: Modified to support exception handling.
	* blox/ErrInspect.st: Modified to support exception handling.

Wed Sep  2 12:34:56 1998  Paolo Bonzini  (bonzini@gnu.org)

	*** Began development of version 1.6

Thu Sep 30 12:34:56 1995  Steve Byrne  (sbb@gnu.org)

	*** Version 1.1.5 released.

Sun Sep 26 12:34:56 1995  Brad Diller (bdiller@docent.com)

	* blox/blox.c: Added support for Dialog and Form widgets. Extended
	Text and List widget support. Corrected minor bugs.

Tue Aug 29 12:34:56 1995  Steve Byrne  (sbb@gnu.org)

	* blox/Load.st: Converted to use new Smalltalk variable for location
	of kernel files.

Sun Jul 16 12:34:56 1995  Steve Byrne  (sbb@gnu.org)

	* blox/BBrowser.st: More updates to contextInspector>>init:
	from Brad Diller (bdiller@docent.com).
	* blox/BBrowser.st: Updated with Brad Diller (bdiller@docent.com)'s changes/fixes.  Removed
	#changed:/#update: usage.

Wed Jul 12 12:34:56 1995  Brad Diller (bdiller@docent.com)

	* blox/PList.st: Modified extensively to support revamped window
	management system.
	* blox/PRadioBtn.st: Modified extensively to support revamped window
	management system.
	* blox/Primitive.st: Modified extensively to support revamped window
	management system.
	* blox/TopLevel.st: Modified extensively to support revamped window
	management system.
	* blox/View.st: Modified extensively to support revamped window
	management system.

Mon May  1 12:34:56 1995  Steve Byrne  (sbb@gnu.org)

	* blox/Blox.st: Switched to using the new C type models.

Sat Feb 25 12:34:56 1995  Brad Diller (bdiller@docent.com)

	* blox/ModalDialog.st: Created.

Thu Sep 15 12:34:56 1994  Steve Byrne  (sbb@gnu.org)

	*** Version 1.2.alpha1 released.

Tue Jul 12 12:34:56 1994  Steve Byrne  (sbb@gnu.org)

	* blox/Blox.st: Added insert at end.

Sat Jul  9 12:34:56 1994  Steve Byrne  (sbb@gnu.org)

	* blox/BBrowser.st: Created about a week ago.

Mon Jul  4 12:34:45 1994  Steve Byrne  (sbb@gnu.org)

	* blox/blox.c: Serious hacking this weekend to make it work properly.

Fri Feb  4 12:34:56 1994  Steve Byrne  (sbb@gnu.org)

	* blox/blox.c: created (using Xaw Athena Widgets).

Fri Oct 29 12:34:56 1993  Brad Diller (bdiller@docent.com)

	* blox/ClassBrow.st: Created.

Wed Oct 27 12:34:56 1993  Brad Diller (bdiller@docent.com)

	* blox/DictInspect.st: Created.
	* blox/Inspector.st: Created.

Mon Oct 11 12:34:56 1993  Brad Diller (bdiller@docent.com)

	* blox/BrowserMain.st: created.
	* blox/MethSetBrow.st: Created.
	* blox/PRadioBtn.st: Created.

Fri Oct  1 12:34:56 1993  Brad Diller (bdiller@docent.com)

	* blox/Menu.st: Created.

Sat Sep 18 12:34:56 1993  Brad Diller (bdiller@docent.com)

	* blox/GuiData.st: Created.
	* blox/PList.st: Created.
	* blox/Primitive.st: Created.
	* blox/Prompter.st: Created.
	* blox/View.st: Created.

